--[[
	Designed and coded by Edgar De Loa.
	Facts by www.ChuckNorrisFacts.com
	Please visit www.eDeloa.com
	Distribute freely
]]--



local RNum = 0;
local Quote = "";

function Chuck_Msg(msg)
    if( DEFAULT_CHAT_FRAME ) then
        DEFAULT_CHAT_FRAME:AddMessage(msg);
    end
end

function Chuck_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");

	SLASH_ChuckCMD1 = "/chuck";
	SlashCmdList["ChuckCMD"] = Chuck_Command;
end

function Chuck_Command(param1)
	NumFacts = table.getn( Facts );
    RNum = math.random( NumFacts );
    Quote = Facts[RNum];
    qArr = splitQ(Quote);
	local start, finish, command, value = string.find(param1, "(%w+) (%w+)");
	if string.lower(param1) == "s" then param1 = "say" end;
	if string.lower(param1) == "y" then param1 = "yell" end;
	if string.lower(param1) == "p" then param1 = "party" end;
	if string.lower(param1) == "g" then param1 = "guild" end;
	if string.lower(param1) == "r" then param1 = "raid" end;
	if string.lower(param1) == "o" then param1 = "officer" end;
	if (string.lower(param1) == "say") or (string.lower(param1) == "yell") or (string.lower(param1) == "party") or (string.lower(param1) == "guild") or (string.lower(param1) == "raid") or (string.lower(param1) == "officer") then
		for i = 0, table.getn(qArr) do SendChatMessage(qArr[i], param1, this.language); end
	elseif (string.lower(param1) == "1") or (string.lower(param1) == "2") or (string.lower(param1) == "3") or (string.lower(param1) == "4") or (string.lower(param1) == "5") or (string.lower(param1) == "6") or (string.lower(param1) == "7") or (string.lower(param1) == "8") or (string.lower(param1) == "9") then
		local MyChannel = GetChannelName(param1);
		if (MyChannel ~= nil) then
			for i = 0, table.getn(qArr) do SendChatMessage(qArr[i], "CHANNEL", this.language, MyChannel); end
		end
	elseif (command ~=nil and string.lower(command) == "whisper") then
		if (value ~=nil) then
			for i = 0, table.getn(qArr) do SendChatMessage(qArr[i], "WHISPER", this.language, value); end
		elseif (value == nil) then
			Chuck_Msg("|cffffff00 You must enter a name to whisper to");
		end
	else
		Chuck_Usage();
	end
end

function splitQ(quote) -- Added by Terrin to do multiple lines
        array = {};
        maxLen = 255;
        qLen = math.ceil(string.len(quote) / 255, 0);
        if qLen > 1 then
			for i = 0, qLen - 1  do
				if string.len(quote) < 255 then maxLen = string.len(quote) else maxlen = 255 end
				array[i] = string.sub(quote, 0, maxLen);
				quote = string.sub(quote, maxLen);
			end
        else
			array[0] = quote;
        end       
    return array;
end

function Chuck_Usage() 
    Chuck_Msg("|cffffff00 Usage:\n");
    Chuck_Msg("   Type /Chuck and then the channel that you wish to post in\n");
    Chuck_Msg("   /Chuck guild\n");
    Chuck_Msg("   /Chuck raid\n");
    Chuck_Msg("   /Chuck say\n");
    Chuck_Msg("   /Chuck yell\n");
    Chuck_Msg("   /Chuck party\n");
    Chuck_Msg("   /Chuck officer\n");
    Chuck_Msg("   /Chuck whisper <PlayerName>\n");
    Chuck_Msg("   /Chuck <ChannelNumber> - such as 1,2, 3, etc");
    Chuck_Msg("|cffffff00 Check the ReadMe for more information.\n");
    
end

function Chuck_OnEvent()
end
